/**
 *
 */
export class DialogRedirectionVisitor {
    constructor(value) {
        if (typeof value === 'string') {
            this._enclosedJsonObject = JSON.parse(value);
        }
        else {
            this._enclosedJsonObject = value;
        }
    }
    // --- State Management Helpers --- //
    static propagateDialogId(dialogRedirection, dialogId) {
        new DialogRedirectionVisitor(dialogRedirection).propagateDialogId(dialogId);
    }
    static propagateTenantIdAndSessionId(dialogRedirection, tenantId, sessionId) {
        new DialogRedirectionVisitor(dialogRedirection).propagateTenantIdAndSessionId(tenantId, sessionId);
    }
    static visitId(dialogRedirection) {
        return new DialogRedirectionVisitor(dialogRedirection).visitId();
    }
    // --- State Import/Export --- //
    copyAsJsonObject() {
        return JSON.parse(this.copyAsJsonString());
    }
    copyAsJsonString() {
        return JSON.stringify(this.enclosedJsonObject());
    }
    enclosedJsonObject() {
        return this._enclosedJsonObject;
    }
    // --- State Management --- //
    propagateDialogId(dialogId) {
        this.enclosedJsonObject()['id'] = dialogId;
        this.enclosedJsonObject()['dialogId'] = dialogId;
    }
    propagateTenantIdAndSessionId(tenantId, sessionId) {
        this.enclosedJsonObject()['tenantId'] = tenantId;
        this.enclosedJsonObject()['sessionId'] = sessionId;
    }
    visitDialogId() {
        return this.enclosedJsonObject().dialogId;
    }
    visitId() {
        return this.enclosedJsonObject().id;
    }
}
