import { ContentRedirectionVisitor } from '../proxy/ContentRedirectionVisitor';
import { DialogRedirectionVisitor } from '../proxy/DialogRedirectionVisitor';
import { DialogVisitor } from '../proxy/DialogVisitor';
import { LargePropertyVisitor } from '../proxy/LargePropertyVisitor';
import { RecordSetVisitor } from '../proxy/RecordSetVisitor';
import { RecordVisitor } from '../proxy/RecordVisitor';
import { SessionVisitor } from '../proxy/SessionVisitor';
import { StringDictionary } from '../util/StringDictionary';
import { SdaDialogDelegateStateVisitor } from './SdaDialogDelegateStateVisitor';
export declare class SdaDialogDelegateTools {
    static OFFLINE_BRIEFCASE_DIALOG_COMMENTS_ID: string;
    static OFFLINE_BRIEFCASE_DIALOG_DETAILS_ID: string;
    static OFFLINE_BRIEFCASE_DIALOG_ROOT_ID: string;
    static OFFLINE_BRIEFCASE_DIALOG_WORK_PACKAGES_ID: string;
    static OFFLINE_WORK_PACKAGES_DIALOG_LIST_ID: string;
    static OFFLINE_WORK_PACKAGES_DIALOG_ROOT_ID: string;
    static BRIEFCASE_DETAILS_DIALOG_NAME: string;
    static BRIEFCASE_MOBILE_COMMENTS_DIALOG_NAME: string;
    static BRIEFCASE_ROOT_DIALOG_NAME: string;
    static BRIEFCASE_WORK_PACKAGES_DIALOG_NAME: string;
    static DOCUMENTS_ROOT_DIALOG_NAME: string;
    static DOCUMENTS_PROPERTIES_DIALOG_NAME: string;
    static DOCUMENTS_LIST_DIALOG_NAME: string;
    static TAGS_ROOT_DIALOG_NAME: string;
    static TAGS_PROPERTIES_DIALOG_NAME: string;
    static TAGS_LIST_DIALOG_NAME: string;
    static WORK_PACKAGES_LIST_DIALOG_NAME: string;
    static WORK_PACKAGES_ROOT_DIALOG_NAME: string;
    private static OFFLINE_WORKBENCH_ACTION_MAP;
    private static DIALOG_NAME_TO_OFFLINE_DIALOG_ID_MAP;
    private static NAVIGATION_DIALOG_KEY;
    private static NAVIGATION_REDIRECTION_KEY;
    private static OFFLINE_DOCUMENTS_DIALOG_LIST_ID_PREFIX;
    private static OFFLINE_DOCUMENTS_DIALOG_LIST_ID;
    private static OFFLINE_DOCUMENTS_DIALOG_PROPERTIES_ID_PREFIX;
    private static OFFLINE_DOCUMENTS_DIALOG_PROPERTIES_ID;
    private static OFFLINE_DOCUMENTS_DIALOG_ROOT_ID_PREFIX;
    private static OFFLINE_DOCUMENTS_DIALOG_ROOT_ID;
    private static OFFLINE_TAGS_DIALOG_LIST_ID_PREFIX;
    private static OFFLINE_TAGS_DIALOG_LIST_ID;
    private static OFFLINE_TAGS_DIALOG_PROPERTIES_ID_PREFIX;
    private static OFFLINE_TAGS_DIALOG_PROPERTIES_ID;
    private static OFFLINE_TAGS_DIALOG_ROOT_ID_PREFIX;
    private static OFFLINE_TAGS_DIALOG_ROOT_ID;
    private static ADD_TO_BRIEFCASE_MENU_ACTION_ID;
    private static BRIEFCASE_WORKBENCH_ACTION_ID;
    private static ENTER_OFFLINE_MODE_MENU_ACTION_ID;
    private static EXIT_OFFLINE_MODE_MENU_ACTION_ID;
    private static OPEN_MENU_ACTION_ID;
    private static OPEN_LATEST_FILE_MENU_ACTION_ID;
    private static REMOVE_FROM_BRIEFCASE_MENU_ACTION_ID;
    private static SHOW_TAGS_MENU_ACTION_ID;
    private static WORK_PACKAGES_WORKBENCH_ACTION_ID;
    private static EDITOR_DIALOG_MODEL_TYPE;
    private static QUERY_DIALOG_MODEL_TYPE;
    private static RECORD_MODEL_TYPE;
    private static RECORD_SET_MODEL_TYPE;
    private static SESSION_ID_MODEL_TYPE;
    private static ONLINE_PROPERTY_NAME;
    private static DIALOG_DELEGATE_STATE_KEY;
    private static OFFLINE_DOCUMENTS_REDIRECTION_KEY;
    private static OFFLINE_DOCUMENTS_DIALOG_ROOT_KEY;
    private static OFFLINE_DOCUMENTS_DIALOG_PROPERTIES_RECORD_KEY;
    private static OFFLINE_DOCUMENTS_DIALOG_LIST_RECORD_SET_KEY;
    private static OFFLINE_SESSION_KEY;
    private static OFFLINE_TAGS_REDIRECTION_KEY;
    private static OFFLINE_TAGS_DIALOG_ROOT_KEY;
    private static OFFLINE_TAGS_DIALOG_PROPERTIES_RECORD_KEY;
    private static OFFLINE_TAGS_DIALOG_LIST_RECORD_SET_KEY;
    private static OFFLINE_WORK_PACKAGES_LIST_RECORD_SET_KEY;
    private static OFFLINE_WORK_PACKAGES_REDIRECTION_KEY;
    private static OFFLINE_WORK_PACKAGES_DIALOG_ROOT_KEY;
    static constructAddToBriefcaseNullRedirection(tenantId: string, sessionId: string, referringDialogId: string): StringDictionary;
    static constructEnterOfflineModeNullRedirection(tenantId: string, sessionId: string): StringDictionary;
    static constructExitOfflineModeNullRedirection(tenantId: string, sessionId: string): StringDictionary;
    static constructOfflineLogoutResponse(sessionId: string): {
        sessionId: string;
        type: string;
    };
    static constructRemoveFromBriefcaseNullRedirection(tenantId: string, sessionId: string, referringDialogId: string): StringDictionary;
    static getOfflineDocumentsDialogListId(workPackageId: string): string;
    static getOfflineDocumentsDialogPropertiesId(workPackageId: string): string;
    static getOfflineDocumentsDialogRootId(workPackageId: string): string;
    static getOfflineTagsDialogListId(workPackageId: string): string;
    static getOfflineTagsDialogPropertiesId(workPackageId: string): string;
    static getOfflineTagsDialogRootId(workPackageId: string): string;
    static isBriefcaseWorkbenchActionRequest(resourcePathElems: string[]): boolean;
    static isEnterOfflineModeMenuActionRequest(resourcePathElems: string[]): boolean;
    static isExitOfflineModeMenuActionRequest(resourcePathElems: string[]): boolean;
    static isOfflineBriefcaseCommentsRequest(resourcePathElems: string[]): boolean;
    static isOfflineBriefcaseDialogId(dialogId: string): boolean;
    static isOfflineBriefcaseDetailsDialogId(dialogId: string): boolean;
    static isOfflineBriefcaseWorkPackagesDialogId(dialogId: string): boolean;
    static isOfflineBriefcaseWorkPackagesRequest(resourcePathElems: string[]): boolean;
    static isOfflineBriefcaseCommentsDialogId(dialogId: string): boolean;
    static isOfflineDocumentContentRequest(resourcePathElems: string[]): boolean;
    static isOfflineDocumentOpenLatestFileMenuActionRequest(resourcePathElems: string[]): boolean;
    static isOfflineDocumentsListRecordSetRequest(resourcePathElems: string[]): boolean;
    static isOfflineDocumentsPropertiesDialogId(dialogId: string): boolean;
    static isOfflineDocumentsRootDialogRequest(resourcePathElems: string[]): boolean;
    static isOfflineShowTagsMenuActionRequest(resourcePathElems: string[]): boolean;
    static isOfflineTagsListRecordSetRequest(resourcePathElems: string[]): boolean;
    static isOfflineTagsPropertiesDialogId(dialogId: string): boolean;
    static isOfflineTagsRootDialogRequest(resourcePathElems: string[]): boolean;
    static isOfflineWorkPackagesListRecordSetRequest(resourcePathElems: string[]): boolean;
    static isOfflineWorkPackagesOpenMenuActionRequest(resourcePathElems: string[]): boolean;
    static isOfflineWorkPackagesRootDialogRequest(resourcePathElems: string[]): boolean;
    static isWorkPackagesAddToBriefcaseMenuActionRequest(resourcePathElems: string[]): boolean;
    static isWorkPackagesListRecordSet(resourcePathElems: string[], jsonObject: any): boolean;
    static isWorkPackagesRemoveFromBriefcaseMenuActionRequest(resourcePathElems: string[]): boolean;
    static isWorkPackagesWorkbenchActionRequest(resourcePathElems: string[]): boolean;
    static isWorkPackagesRootDialog(jsonObject: any): boolean;
    static insertBriefcaseMetaDataIntoWorkPackagesDialog(originalDialog: StringDictionary): StringDictionary;
    static mapDialogNameToOfflineDialogId(name: string): any;
    static readDialogDelegateStateVisitor(tenantId: string, userId: string): Promise<SdaDialogDelegateStateVisitor>;
    static readOfflineDocumentContentChunk(tenantId: string, userId: string, contentId: any, sequence: number): Promise<LargePropertyVisitor>;
    static readOfflineDocumentContentRedirection(tenantId: string, userId: string, documentsListDialogId: string, documentId: string): Promise<ContentRedirectionVisitor>;
    static readOfflineDocumentsListRecordSet(tenantId: string, userId: string, dialogId: string): Promise<RecordSetVisitor>;
    static readOfflineDocumentsPropertiesRecord(tenantId: string, userId: string, dialogId: string): Promise<RecordVisitor>;
    static readOfflineDocumentsRedirection(tenantId: string, userId: string, workPackageId: string): Promise<DialogRedirectionVisitor>;
    static readOfflineDocumentsRootDialog(tenantId: string, userId: string, dialogId: string): Promise<DialogVisitor>;
    static readOfflineSession(tenantId: string, userId: string): Promise<SessionVisitor>;
    static readOfflineTagsListRecordSet(tenantId: string, userId: string, dialogId: string): Promise<RecordSetVisitor>;
    static readOfflineTagsPropertiesRecord(tenantId: string, userId: string, dialogId: string): Promise<RecordVisitor>;
    static readOfflineTagsRedirection(tenantId: string, userId: string, workPackageId: string): Promise<DialogRedirectionVisitor>;
    static readOfflineTagsRootDialog(tenantId: string, userId: string, dialogId: string): Promise<DialogVisitor>;
    static readOfflineWorkPackagesRedirection(tenantId: string, userId: string): Promise<DialogRedirectionVisitor>;
    static readOfflineWorkPackagesRootDialog(tenantId: string, userId: string): Promise<DialogVisitor>;
    static showAllStorageKeys(): Promise<void>;
    static writeDialogDelegateState(tenantId: string, stateVisitor: SdaDialogDelegateStateVisitor): Promise<void>;
    static writeOfflineDocumentContentChunk(tenantId: string, userId: string, offlineDocumentsListDialogId: string, documentId: string, sequence: number, largePropertyVisitor: LargePropertyVisitor): Promise<void>;
    static writeOfflineDocumentContentRedirection(tenantId: string, userId: string, documentsListDialogId: string, documentId: string, contentRedirectionVisitor: ContentRedirectionVisitor): Promise<void>;
    static writeOfflineDocumentsDialogListRecordSet(tenantId: string, userId: string, workPackageId: string, recordSetVisitor: RecordSetVisitor): Promise<void>;
    static writeOfflineDocumentsDialogPropertiesRecord(tenantId: string, userId: string, workPackageId: string, recordVisitor: RecordVisitor): Promise<void>;
    static writeOfflineDocumentsDialogRoot(tenantId: string, userId: string, workPackageId: string, dialogVisitor: DialogVisitor): Promise<void>;
    static writeOfflineDocumentsRedirection(tenantId: string, userId: string, workPackageId: string, dialogRedirectionVistor: DialogRedirectionVisitor): Promise<void>;
    static writeOfflineSession(tenantId: string, userId: string, offlineSessionVisitor: SessionVisitor): Promise<void>;
    static writeOfflineTagsDialogListRecordSet(tenantId: string, userId: string, workPackageId: string, recordSetVisitor: RecordSetVisitor): Promise<void>;
    static writeOfflineTagsDialogPropertiesRecord(tenantId: string, userId: string, workPackageId: string, recordVisitor: RecordVisitor): Promise<void>;
    static writeOfflineTagsDialogRoot(tenantId: string, userId: string, workPackageId: string, dialogVisitor: DialogVisitor): Promise<void>;
    static writeOfflineTagsRedirection(tenantId: string, userId: string, workPackageId: string, dialogRedirectionVistor: DialogRedirectionVisitor): Promise<void>;
    static writeOfflineWorkPackagesDialogRoot(tenantId: string, userId: string, dialogVisitor: DialogVisitor): Promise<void>;
    static writeOfflineWorkPackagesRedirection(tenantId: string, userId: string, dialogRedirectionVistor: DialogRedirectionVisitor): Promise<void>;
    private static constructOfflineModeNullRedirection(tenantId, sessionId, actionId);
    private static createStorageKey(tenantId, userId, keyTemplate);
}
