import { JsonClientResponse } from '../client/JsonClientResponse';
import { FetchClient } from '../ws/FetchClient';
export declare class DialogProxyTools {
    static ACTIONS: string;
    static AVAILABLE_VALUES: string;
    static AVAILABLE_VIEWS: string;
    static CONTENT: string;
    static DIALOGS: string;
    static RECORD: string;
    static RECORDS: string;
    static REDIRECTIONS: string;
    static SELECTED_VIEW: string;
    static SESSIONS: string;
    static TENANTS: string;
    static VIEW_MODE: string;
    static WORKBENCHES: string;
    static ACTION_PARAMETERS_MODEL_TYPE: string;
    static ANNOTATION_MODEL_TYPE: string;
    static DIALOG_MESSAGE_MODEL_TYPE: string;
    static EDITOR_DIALOG_MODEL_TYPE: string;
    static LOGIN_MODEL_TYPE: string;
    static PROPERTY_MODEL_TYPE: string;
    static PROPERTY_DEF_MODEL_TYPE: string;
    static QUERY_DIALOG_MODEL_TYPE: string;
    static RECORD_MODEL_TYPE: string;
    static RECORD_SET_MODEL_TYPE: string;
    static SESSION_MODEL_TYPE: string;
    static COMMON_FETCH_CLIENT: FetchClient;
    static commonFetchClient(): FetchClient;
    static constructDialogMessageModel(message: string): {
        type: string;
        message: string;
    };
    static constructLoginModel(userId: string, password: string): object;
    static constructRequestNotValidDuringOfflineMode(action: string, resourcePath: string): Promise<JsonClientResponse>;
    static constructNullRedirectionId(): string;
    static deconstructDeleteSessionPath(path: string[]): any;
    static deconstructGetDialogPath(path: string[]): any;
    static deconstructGetRecordPath(path: string[]): any;
    static deconstructGetRedirectionPath(path: string[]): any;
    static deconstructPostMenuActionPath(path: string[]): any;
    static deconstructPostRecordsPath(path: string[]): any;
    static deconstructPostSessionContentPath(path: string[]): any;
    static deconstructPostSessionsPath(path: string[]): any;
    static deconstructPostWorkbenchActionPath(path: string[]): any;
    static deleteAllDialogState(tenantId: string, userId: string, dialogId: string): void;
    static deleteAllDialogStateFor(tenantId: string, userId: string, dialog: any): void;
    static deleteAllState(tenantId: string, userId: string): void;
    static deleteAllWorkbenchNavigation(tenantId: string, userId: string, navigationKey: string): void;
    static deleteDialogAliasState(tenantId: string, userId: string, dialogId: string): void;
    static deleteDialogParentState(tenantId: string, userId: string, childId: string): void;
    static deleteDialogReferringAliasState(tenantId: string, userId: string, dialogId: string): void;
    static deleteDialogState(tenantId: string, userId: string, dialogId: string): void;
    static deleteNavigationState(tenantId: string, userId: string, navigationId: string): void;
    static deletePersistentState(tenantId: string, userId: string, stateId: string): void;
    static deleteRecordSetState(tenantId: string, userId: string, dialogId: string): void;
    static deleteRecordState(tenantId: string, userId: string, dialogId: string): void;
    static deleteRedirectionState(tenantId: string, userId: string, redirectionId: string): void;
    static deleteSessionState(tenantId: string, userId: string): void;
    static findDialogState(tenantId: string, userId: string, dialogId: string): any;
    static findDialogStateWithin(tenantId: string, userId: string, dialog: any, targetId: string): any;
    static findRecordProperty(record: any, propertyName: string): any;
    static findRecordPropertyValue(record: any, propertyName: string): any;
    static findRootDialogState(tenantId: string, userId: string, dialogId: string): any;
    static isCreateSessionRequest(path: string[]): boolean;
    static isDeleteSessionRequest(path: string[]): boolean;
    static isGetAvailableViews(path: string[]): boolean;
    static isGetDialog(path: string[]): boolean;
    static isGetRecord(path: string[]): boolean;
    static isGetRedirection(path: string[]): boolean;
    static isGetSelectedView(path: string[]): boolean;
    static isGetSession(path: string[]): boolean;
    static isGetTenant(path: string[]): boolean;
    static isGetTenants(path: string[]): boolean;
    static isGetViewMode(path: string[]): boolean;
    static isGetWorkbenches(path: string[]): boolean;
    static isPostAvailableValues(path: string[]): boolean;
    static isPostMenuAction(path: string[]): boolean;
    static isPostRecords(path: string[]): boolean;
    static isPostSession(path: string[]): boolean;
    static isPostSessionContent(path: string[]): boolean;
    static isPostWorkbenchAction(path: string[]): boolean;
    static isPutRecord(path: string[]): boolean;
    static isPutSelectedView(path: string[]): boolean;
    static isPutViewMode(path: string[]): boolean;
    static isActionParametersObject(jsonObject: object): boolean;
    static isAnnotationObject(jsonObject: object): boolean;
    static isDialogObject(jsonObject: object): boolean;
    static isLoginObject(jsonObject: object): boolean;
    static isPropertyObject(jsonObject: object): boolean;
    static isPropertyDefObject(jsonObject: object): boolean;
    static isRecordObject(jsonObject: object): boolean;
    static isRecordSetObject(jsonObject: object): boolean;
    static isSessionObject(jsonObject: object): boolean;
    static readDialogAliasState(tenantId: string, userId: string, dialogId: string): Promise<any>;
    static readDialogParentState(tenantId: string, userId: string, childId: string): any;
    static readDialogReferringAliasState(tenantId: string, userId: string, dialogId: string): Promise<any>;
    static readDialogState(tenantId: string, userId: string, dialogId: string): any;
    static readNavigationState(tenantId: string, userId: string, navigationId: string): any;
    static readPersistentState(tenantId: string, userId: string, stateId: string): Promise<any>;
    static readRecordSetState(tenantId: string, userId: string, dialogId: string): any;
    static readRecordState(tenantId: string, userId: string, dialogId: string): any;
    static readRedirectionState(tenantId: string, userId: string, redirectionId: string): any;
    static readSessionState(tenantId: string, userId: string): any;
    static writeAllDialogParentState(tenantId: string, userId: string, parent: any): void;
    static writeDialogAliasState(tenantId: string, userId: string, dialogId: string, alias: any): Promise<boolean>;
    static writeDialogParentState(tenantId: string, userId: string, child: any, childIndex: number, parent: any): void;
    static writeDialogReferringAliasState(tenantId: string, userId: string, dialogId: string, referringAlias: any): void;
    static writeDialogState(tenantId: string, userId: string, dialog: any): Promise<boolean>;
    static writePersistentState(tenantId: string, userId: string, stateId: string, state: any): Promise<boolean>;
    static writeRecordSetState(tenantId: string, userId: string, dialogId: string, recordSet: any): Promise<boolean>;
    static writeRecordState(tenantId: string, userId: string, dialogId: string, record: any): Promise<boolean>;
    static writeNavigationState(tenantId: string, userId: string, navigation: any): Promise<boolean>;
    static writeRedirectionState(tenantId: string, userId: string, redirection: any): Promise<boolean>;
    static writeSessionState(session: any): Promise<boolean>;
}
